
/*  A Bison parser, made from /lhome/htauriai/lbtt-releases/lbtt-1.0.0/src/Config-parse.yy
    by GNU Bison version 1.28  */

#define YYBISON 1  /* Identify Bison output.  */

#define	CFG_ALGORITHM	257
#define	CFG_ENABLED	258
#define	CFG_NAME	259
#define	CFG_PARAMETERS	260
#define	CFG_PROGRAMPATH	261
#define	CFG_GLOBALOPTIONS	262
#define	CFG_COMPARISONTEST	263
#define	CFG_CONSISTENCYTEST	264
#define	CFG_INTERACTIVE	265
#define	CFG_INTERSECTIONTEST	266
#define	CFG_MODELCHECK	267
#define	CFG_ROUNDS	268
#define	CFG_VERBOSITY	269
#define	CFG_STATESPACEOPTIONS	270
#define	CFG_EDGEPROBABILITY	271
#define	CFG_PROPOSITIONS	272
#define	CFG_SIZE	273
#define	CFG_TRUTHPROBABILITY	274
#define	CFG_CHANGEINTERVAL	275
#define	CFG_RANDOMSEED	276
#define	CFG_FORMULAOPTIONS	277
#define	CFG_ABBREVIATEDOPERATORS	278
#define	CFG_ANDPRIORITY	279
#define	CFG_BEFOREPRIORITY	280
#define	CFG_DEFAULTOPERATORPRIORITY	281
#define	CFG_EQUIVALENCEPRIORITY	282
#define	CFG_FALSEPRIORITY	283
#define	CFG_FINALLYPRIORITY	284
#define	CFG_GENERATEMODE	285
#define	CFG_GLOBALLYPRIORITY	286
#define	CFG_IMPLICATIONPRIORITY	287
#define	CFG_NEXTPRIORITY	288
#define	CFG_NOTPRIORITY	289
#define	CFG_ORPRIORITY	290
#define	CFG_OUTPUTMODE	291
#define	CFG_PROPOSITIONPRIORITY	292
#define	CFG_RELEASEPRIORITY	293
#define	CFG_STRONGRELEASEPRIORITY	294
#define	CFG_TRUEPRIORITY	295
#define	CFG_UNTILPRIORITY	296
#define	CFG_WEAKUNTILPRIORITY	297
#define	CFG_XORPRIORITY	298
#define	CFG_TRUTH_VALUE	299
#define	CFG_INTERACTIVITY_VALUE	300
#define	CFG_FORMULA_MODE_VALUE	301
#define	CFG_STATESPACE_MODE_VALUE	302
#define	CFG_PRODUCT_TYPE_VALUE	303
#define	CFG_INTEGER	304
#define	CFG_REAL	305
#define	CFG_INTEGER_INTERVAL	306
#define	CFG_STRING_CONSTANT	307
#define	CFG_LBRACE	308
#define	CFG_RBRACE	309
#define	CFG_EQUALS	310
#define	CFG_BLOCK_ID	311
#define	CFG_OPTION_ID	312
#define	CFG_UNKNOWN	313

#line 20 "Config-parse.yy"


#include <config.h>
#include <cstdio>
#include <string>
#include "Configuration.h"
#include "StringUtil.h"



/******************************************************************************
 *
 * Variables for parsing the configuration file.
 *
 *****************************************************************************/

static Configuration::AlgorithmInformation          /* Stores all the      */
  algorithm_information;                            /* information in a
						     * single `Algorithm'
						     * block in the
						     * configuration file.
						     */

static int algorithm_begin_line;                    /* Input file line number
						     * denoting the beginning
						     * of the most recently
						     * encountered `Algorithm'
						     * block.
						     */

static int expected_token;                          /* Type of a token to be
						     * encountered next when
						     * reading the
						     * configuration file.
						     */

static int current_block_type;                      /* Type of the current
						     * configuration block.
						     */

static int current_option_type;                     /* Type of the current
						     * option name.
						     */

static Configuration* parser_cfg;                   /* Pointer to a
                                                     * Configuration data
                                                     * structure in which
                                                     * the configuration will
                                                     * be stored.
                                                     */

int config_file_line_number;                        /* Number of the current
                                                     * line in the
                                                     * configuration
                                                     * file.
                                                     */



/******************************************************************************
 *
 * Declarations for external functions and variables (provided by the lexer)
 * used when parsing the configuration file.
 *
 *****************************************************************************/

#ifdef YYTEXT_POINTER
extern char* yytext;                                /* Current token in the  */
#else	                                            /* input (provided by    */
extern char yytext[];                               /* the lexer).           */
#endif /* YYTEXT_POINTER */

extern void yyrestart(FILE*);                       /* Changes the input stream
                                                     * for the lexer (provided
                                                     * by the lexer).
                                                     */

extern int yylex();                                 /* Reads the next token
						     * from the input (this
						     * function is provided by
						     * the lexer).
						     */

extern int getCharacter();                          /* Returns the next
                                                     * character in the lexer
                                                     * input stream.
                                                     */



/******************************************************************************
 *
 * Function for reporting parse errors.
 *
 *****************************************************************************/

/* ========================================================================= */
void yyerror(char* error_message)
/* ----------------------------------------------------------------------------
 *
 * Description:   Function for reporting parse errors.
 *
 * Arguments:     error_message  --  An error message.
 *
 * Returns:       Nothing. Instead, throws a
 *                Configuration::ConfigurationException initialized with the
 *                given error message.
 *
 * ------------------------------------------------------------------------- */
{
  string unknown_token(yytext);
  int c;

  do
  {
    c = getCharacter();
    if (c != EOF && c != ' ' && c != '\t' && c != '\n')
      unknown_token += static_cast<char>(c);
  }
  while (c != EOF && c != ' ' && c != '\t' && c != '\n');

  string msg;

  switch (expected_token)
  {
    case CFG_BLOCK_ID :
      msg = string("unrecognized block identifier (`") + unknown_token + "')";
      break;
    case CFG_OPTION_ID :
      msg = string("unrecognized option identifier (`") + unknown_token + "')";
      break;
    case CFG_LBRACE :
      msg = "`{' expected after block identifier";
      break;
    case CFG_EQUALS :
      msg = "`=' expected after option identifier";
      break;
    case CFG_TRUTH_VALUE :
      msg = "truth value expected as option argument";
      break;
    case CFG_INTERACTIVITY_VALUE :
      msg = "interactivity mode expected as option argument";
      break;
    case CFG_FORMULA_MODE_VALUE :
      msg = "formula generation mode expected as option argument";
      break;
    case CFG_STATESPACE_MODE_VALUE :
      msg = "state space generation mode expected as option argument";
      break;
    case CFG_PRODUCT_TYPE_VALUE :
      msg = "model checking mode expected as option argument";
      break;
    case CFG_INTEGER :
      msg = "nonnegative integer expected as option argument";
      break;
    case CFG_INTEGER_INTERVAL :
      msg = "nonnegative integer or an integer interval expected as option"
	    " argument";
      break;
    case CFG_REAL :
      msg = "nonnegative real number expected as option argument";
      break;
    case CFG_STRING_CONSTANT :
      msg = "string constant expected as option argument";
      break;
    default :
      msg = error_message;
      break;
  }

  throw Configuration::ConfigurationException(config_file_line_number, msg);
}



/******************************************************************************
 *
 * Functions for performing various bound checks for the values of different
 * options in the configuration file.
 *
 *****************************************************************************/

/* ========================================================================= */
void checkIntegerRange
  (long int value, const struct Configuration::IntegerRange& range,
   bool show_line_number_if_error = true)
/* ----------------------------------------------------------------------------
 *
 * Description:   Checks that a value given to a configuration is within the
 *                acceptable range.
 *
 * Arguments:     value                      --  Integer value for a
 *                                               configuration option.
 *                range                      --  A reference to a constant
 *                                               struct
 *                                               Configuration::IntegerRange.
 *                show_line_number_if_error  --  If the value is not within the
 *                                               specified range, this
 *                                               parameter determines whether a
 *                                               configuration file line number
 *                                               is shown together with the
 *                                               error message.
 *
 * Returns:       Nothing.
 *
 * ------------------------------------------------------------------------- */
{
  if (value < range.min || value > range.max)
    throw Configuration::ConfigurationException
            ((show_line_number_if_error ? config_file_line_number : -1),
	     range.error_message);
}

/* ========================================================================= */
void checkProbability(double value, bool show_line_number_if_error = true)
/* ----------------------------------------------------------------------------
 *
 * Description:   Checks whether a probability value specified in the program
 *                configuration is between 0.0 and 1.0 inclusive.
 *
 * Argument:      value                      --  A value supposed to denote a
 *                                               probability.
 *                show_line_number_if_error  --  If the value is not within the
 *                                               specified range, this
 *                                               parameter determines whether a
 *                                               configuration file line number
 *                                               is shown together with the
 *                                               error message.
 *
 * Returns:       Nothing.
 *
 * ------------------------------------------------------------------------- */
{
  if (value < 0.0 || value > 1.0)
    throw Configuration::ConfigurationException
            ((show_line_number_if_error ? config_file_line_number : -1),
	     "probability must be between 0.0 and 1.0 inclusive");
}

/* ========================================================================= */
static inline bool isLocked(int option)
/* ----------------------------------------------------------------------------
 *
 * Description:   Checks whether the value of a configuration option can be
 *                initialized from the configuration file.  (This should not be
 *                done if the option was present on the program command line.)
 *
 * Argument:      option  --  The command line option.
 *
 * Returns:       `true' if the value of the option has been overridden in the
 *                command line.
 *
 * ------------------------------------------------------------------------- */
{
  return (parser_cfg->locked_options.find(make_pair(current_block_type,
                                                    option))
	    != parser_cfg->locked_options.end());
}


#line 291 "Config-parse.yy"
typedef union
{
  bool truth_value;

  long int integer;

  Configuration::InteractionMode interactivity_value;

  Configuration::FormulaMode formula_mode_value;

  Configuration::StateSpaceMode statespace_mode_value;

  Configuration::ProductMode product_type_value;

  double real;

  string *str;

  struct
  {
    long int min;
    long int max;
  } integer_interval;
} YYSTYPE;
#include <stdio.h>

#ifndef __cplusplus
#ifndef __STDC__
#define const
#endif
#endif



#define	YYFINAL		257
#define	YYFLAG		-32768
#define	YYNTBASE	60

#define YYTRANSLATE(x) ((unsigned)(x) <= 313 ? yytranslate[x] : 172)

static const char yytranslate[] = {     0,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     1,     3,     4,     5,     6,
     7,     8,     9,    10,    11,    12,    13,    14,    15,    16,
    17,    18,    19,    20,    21,    22,    23,    24,    25,    26,
    27,    28,    29,    30,    31,    32,    33,    34,    35,    36,
    37,    38,    39,    40,    41,    42,    43,    44,    45,    46,
    47,    48,    49,    50,    51,    52,    53,    54,    55,    56,
    57,    58,    59
};

#if YYDEBUG != 0
static const short yyprhs[] = {     0,
     0,     2,     3,     4,     8,    10,    12,    14,    16,    17,
    23,    24,    25,    29,    30,    31,    37,    38,    39,    45,
    46,    47,    53,    54,    55,    61,    62,    68,    69,    70,
    74,    75,    76,    82,    83,    84,    90,    91,    92,    98,
    99,   100,   106,   107,   108,   114,   115,   116,   122,   123,
   124,   130,   131,   137,   138,   139,   143,   144,   145,   151,
   152,   153,   159,   160,   161,   167,   168,   169,   175,   176,
   177,   183,   184,   185,   191,   192,   193,   199,   200,   206,
   207,   208,   212,   213,   214,   220,   221,   222,   228,   229,
   230,   236,   237,   238,   244,   245,   246,   252,   253,   254,
   260,   261,   262,   268,   269,   270,   276,   277,   278,   284,
   285,   286,   292,   293,   294,   300,   301,   302,   308,   309,
   310,   316,   317,   318,   324,   325,   326,   332,   333,   334,
   340,   341,   342,   348,   349,   350,   356,   357,   358,   364,
   365,   366,   372,   373,   374,   380,   381,   382,   388,   389,
   390,   396,   397,   398,   404,   405,   406,   412,   414,   416,
   418
};

static const short yyrhs[] = {    61,
     0,     0,     0,    61,    62,    63,     0,    64,     0,    77,
     0,    96,     0,   115,     0,     0,     3,    65,    54,    66,
    55,     0,     0,     0,    66,    67,    68,     0,     0,     0,
     4,    69,    56,    70,    45,     0,     0,     0,     5,    71,
    56,    72,    53,     0,     0,     0,     6,    73,    56,    74,
    53,     0,     0,     0,     7,    75,    56,    76,    53,     0,
     0,     8,    78,    54,    79,    55,     0,     0,     0,    79,
    80,    81,     0,     0,     0,     9,    82,    56,    83,    45,
     0,     0,     0,    10,    84,    56,    85,    45,     0,     0,
     0,    11,    86,    56,    87,    46,     0,     0,     0,    12,
    88,    56,    89,    45,     0,     0,     0,    13,    90,    56,
    91,    49,     0,     0,     0,    14,    92,    56,    93,    50,
     0,     0,     0,    15,    94,    56,    95,    50,     0,     0,
    16,    97,    54,    98,    55,     0,     0,     0,    98,    99,
   100,     0,     0,     0,    21,   101,    56,   102,    50,     0,
     0,     0,    17,   103,    56,   104,    51,     0,     0,     0,
    31,   105,    56,   106,    48,     0,     0,     0,    18,   107,
    56,   108,    50,     0,     0,     0,    22,   109,    56,   110,
    50,     0,     0,     0,    19,   111,    56,   112,   171,     0,
     0,     0,    20,   113,    56,   114,    51,     0,     0,    23,
   116,    54,   117,    55,     0,     0,     0,   117,   118,   119,
     0,     0,     0,    24,   120,    56,   121,    45,     0,     0,
     0,    25,   122,    56,   123,    50,     0,     0,     0,    26,
   124,    56,   125,    50,     0,     0,     0,    21,   126,    56,
   127,    50,     0,     0,     0,    27,   128,    56,   129,    50,
     0,     0,     0,    28,   130,    56,   131,    50,     0,     0,
     0,    29,   132,    56,   133,    50,     0,     0,     0,    30,
   134,    56,   135,    50,     0,     0,     0,    31,   136,    56,
   137,    47,     0,     0,     0,    32,   138,    56,   139,    50,
     0,     0,     0,    33,   140,    56,   141,    50,     0,     0,
     0,    34,   142,    56,   143,    50,     0,     0,     0,    35,
   144,    56,   145,    50,     0,     0,     0,    36,   146,    56,
   147,    50,     0,     0,     0,    37,   148,    56,   149,    47,
     0,     0,     0,    38,   150,    56,   151,    50,     0,     0,
     0,    18,   152,    56,   153,    50,     0,     0,     0,    22,
   154,    56,   155,    50,     0,     0,     0,    39,   156,    56,
   157,    50,     0,     0,     0,    19,   158,    56,   159,   170,
     0,     0,     0,    40,   160,    56,   161,    50,     0,     0,
     0,    41,   162,    56,   163,    50,     0,     0,     0,    42,
   164,    56,   165,    50,     0,     0,     0,    43,   166,    56,
   167,    50,     0,     0,     0,    44,   168,    56,   169,    50,
     0,    50,     0,    52,     0,    50,     0,    52,     0
};

#endif

#if YYDEBUG != 0
static const short yyrline[] = { 0,
   387,   390,   391,   396,   398,   399,   400,   401,   404,   417,
   444,   445,   450,   452,   458,   462,   466,   472,   476,   480,
   486,   490,   494,   500,   504,   509,   514,   517,   518,   523,
   525,   531,   535,   540,   546,   550,   555,   561,   565,   570,
   576,   580,   585,   591,   595,   600,   606,   610,   621,   627,
   631,   641,   646,   649,   650,   655,   657,   663,   667,   677,
   683,   687,   696,   702,   706,   712,   718,   722,   733,   739,
   743,   749,   755,   760,   760,   766,   770,   780,   785,   788,
   789,   794,   796,   802,   806,   812,   818,   822,   832,   838,
   842,   852,   858,   862,   872,   879,   883,   893,   899,   903,
   913,   919,   923,   933,   939,   943,   953,   959,   963,   969,
   975,   979,   989,   995,   999,  1009,  1015,  1019,  1029,  1035,
  1039,  1049,  1055,  1059,  1069,  1075,  1079,  1084,  1090,  1094,
  1104,  1110,  1114,  1126,  1132,  1136,  1142,  1148,  1152,  1162,
  1168,  1173,  1173,  1179,  1183,  1193,  1199,  1203,  1213,  1219,
  1223,  1233,  1239,  1243,  1253,  1259,  1263,  1274,  1288,  1312,
  1326
};
#endif


#if YYDEBUG != 0 || defined (YYERROR_VERBOSE)

static const char * const yytname[] = {   "$","error","$undefined.","CFG_ALGORITHM",
"CFG_ENABLED","CFG_NAME","CFG_PARAMETERS","CFG_PROGRAMPATH","CFG_GLOBALOPTIONS",
"CFG_COMPARISONTEST","CFG_CONSISTENCYTEST","CFG_INTERACTIVE","CFG_INTERSECTIONTEST",
"CFG_MODELCHECK","CFG_ROUNDS","CFG_VERBOSITY","CFG_STATESPACEOPTIONS","CFG_EDGEPROBABILITY",
"CFG_PROPOSITIONS","CFG_SIZE","CFG_TRUTHPROBABILITY","CFG_CHANGEINTERVAL","CFG_RANDOMSEED",
"CFG_FORMULAOPTIONS","CFG_ABBREVIATEDOPERATORS","CFG_ANDPRIORITY","CFG_BEFOREPRIORITY",
"CFG_DEFAULTOPERATORPRIORITY","CFG_EQUIVALENCEPRIORITY","CFG_FALSEPRIORITY",
"CFG_FINALLYPRIORITY","CFG_GENERATEMODE","CFG_GLOBALLYPRIORITY","CFG_IMPLICATIONPRIORITY",
"CFG_NEXTPRIORITY","CFG_NOTPRIORITY","CFG_ORPRIORITY","CFG_OUTPUTMODE","CFG_PROPOSITIONPRIORITY",
"CFG_RELEASEPRIORITY","CFG_STRONGRELEASEPRIORITY","CFG_TRUEPRIORITY","CFG_UNTILPRIORITY",
"CFG_WEAKUNTILPRIORITY","CFG_XORPRIORITY","CFG_TRUTH_VALUE","CFG_INTERACTIVITY_VALUE",
"CFG_FORMULA_MODE_VALUE","CFG_STATESPACE_MODE_VALUE","CFG_PRODUCT_TYPE_VALUE",
"CFG_INTEGER","CFG_REAL","CFG_INTEGER_INTERVAL","CFG_STRING_CONSTANT","CFG_LBRACE",
"CFG_RBRACE","CFG_EQUALS","CFG_BLOCK_ID","CFG_OPTION_ID","CFG_UNKNOWN","configuration_file",
"configuration_blocks","@1","configuration_block","algorithm_option_block","@2",
"algorithm_options","@3","algorithm_option","@4","@5","@6","@7","@8","@9","@10",
"@11","global_option_block","@12","global_options","@13","global_option","@14",
"@15","@16","@17","@18","@19","@20","@21","@22","@23","@24","@25","@26","@27",
"statespace_option_block","@28","statespace_options","@29","statespace_option",
"@30","@31","@32","@33","@34","@35","@36","@37","@38","@39","@40","@41","@42",
"@43","formula_option_block","@44","formula_options","@45","formula_option",
"@46","@47","@48","@49","@50","@51","@52","@53","@54","@55","@56","@57","@58",
"@59","@60","@61","@62","@63","@64","@65","@66","@67","@68","@69","@70","@71",
"@72","@73","@74","@75","@76","@77","@78","@79","@80","@81","@82","@83","@84",
"@85","@86","@87","@88","@89","@90","@91","@92","@93","@94","@95","formula_size",
"statespace_size", NULL
};
#endif

static const short yyr1[] = {     0,
    60,    61,    62,    61,    63,    63,    63,    63,    65,    64,
    66,    67,    66,    69,    70,    68,    71,    72,    68,    73,
    74,    68,    75,    76,    68,    78,    77,    79,    80,    79,
    82,    83,    81,    84,    85,    81,    86,    87,    81,    88,
    89,    81,    90,    91,    81,    92,    93,    81,    94,    95,
    81,    97,    96,    98,    99,    98,   101,   102,   100,   103,
   104,   100,   105,   106,   100,   107,   108,   100,   109,   110,
   100,   111,   112,   100,   113,   114,   100,   116,   115,   117,
   118,   117,   120,   121,   119,   122,   123,   119,   124,   125,
   119,   126,   127,   119,   128,   129,   119,   130,   131,   119,
   132,   133,   119,   134,   135,   119,   136,   137,   119,   138,
   139,   119,   140,   141,   119,   142,   143,   119,   144,   145,
   119,   146,   147,   119,   148,   149,   119,   150,   151,   119,
   152,   153,   119,   154,   155,   119,   156,   157,   119,   158,
   159,   119,   160,   161,   119,   162,   163,   119,   164,   165,
   119,   166,   167,   119,   168,   169,   119,   170,   170,   171,
   171
};

static const short yyr2[] = {     0,
     1,     0,     0,     3,     1,     1,     1,     1,     0,     5,
     0,     0,     3,     0,     0,     5,     0,     0,     5,     0,
     0,     5,     0,     0,     5,     0,     5,     0,     0,     3,
     0,     0,     5,     0,     0,     5,     0,     0,     5,     0,
     0,     5,     0,     0,     5,     0,     0,     5,     0,     0,
     5,     0,     5,     0,     0,     3,     0,     0,     5,     0,
     0,     5,     0,     0,     5,     0,     0,     5,     0,     0,
     5,     0,     0,     5,     0,     0,     5,     0,     5,     0,
     0,     3,     0,     0,     5,     0,     0,     5,     0,     0,
     5,     0,     0,     5,     0,     0,     5,     0,     0,     5,
     0,     0,     5,     0,     0,     5,     0,     0,     5,     0,
     0,     5,     0,     0,     5,     0,     0,     5,     0,     0,
     5,     0,     0,     5,     0,     0,     5,     0,     0,     5,
     0,     0,     5,     0,     0,     5,     0,     0,     5,     0,
     0,     5,     0,     0,     5,     0,     0,     5,     0,     0,
     5,     0,     0,     5,     0,     0,     5,     1,     1,     1,
     1
};

static const short yydefact[] = {     2,
     3,     0,     9,    26,    52,    78,     4,     5,     6,     7,
     8,     0,     0,     0,     0,    11,    28,    54,    80,    12,
    29,    55,    81,    10,     0,    27,     0,    53,     0,    79,
     0,    14,    17,    20,    23,    13,    31,    34,    37,    40,
    43,    46,    49,    30,    60,    66,    72,    75,    57,    69,
    63,    56,   131,   140,    92,   134,    83,    86,    89,    95,
    98,   101,   104,   107,   110,   113,   116,   119,   122,   125,
   128,   137,   143,   146,   149,   152,   155,    82,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,    15,    18,    21,    24,    32,    35,    38,    41,    44,
    47,    50,    61,    67,    73,    76,    58,    70,    64,   132,
   141,    93,   135,    84,    87,    90,    96,    99,   102,   105,
   108,   111,   114,   117,   120,   123,   126,   129,   138,   144,
   147,   150,   153,   156,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,    16,    19,    22,
    25,    33,    36,    39,    42,    45,    48,    51,    62,    68,
   160,   161,    74,    77,    59,    71,    65,   133,   158,   159,
   142,    94,   136,    85,    88,    91,    97,   100,   103,   106,
   109,   112,   115,   118,   121,   124,   127,   130,   139,   145,
   148,   151,   154,   157,     0,     0,     0
};

static const short yydefgoto[] = {   255,
     1,     2,     7,     8,    12,    20,    25,    36,    79,   165,
    80,   166,    81,   167,    82,   168,     9,    13,    21,    27,
    44,    83,   169,    84,   170,    85,   171,    86,   172,    87,
   173,    88,   174,    89,   175,    10,    14,    22,    29,    52,
    94,   180,    90,   176,    96,   182,    91,   177,    95,   181,
    92,   178,    93,   179,    11,    15,    23,    31,    78,   101,
   187,   102,   188,   103,   189,    99,   185,   104,   190,   105,
   191,   106,   192,   107,   193,   108,   194,   109,   195,   110,
   196,   111,   197,   112,   198,   113,   199,   114,   200,   115,
   201,    97,   183,   100,   186,   116,   202,    98,   184,   117,
   203,   118,   204,   119,   205,   120,   206,   121,   207,   231,
   223
};

static const short yypact[] = {-32768,
     2,    24,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,   -49,    -9,    -8,     3,-32768,-32768,-32768,-32768,     1,
     4,     5,     6,-32768,    37,-32768,    40,-32768,    17,-32768,
   -18,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,   -23,     7,
     8,     9,    10,    11,    12,    13,    14,    15,    16,    18,
    19,    20,    21,    22,    23,    25,    26,    27,    28,    29,
    30,    31,    32,    33,    34,    35,    36,    38,    39,    41,
    42,    43,    44,    45,    46,    47,    48,    49,    50,    51,
    52,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,    64,    57,    58,    59,    68,    69,
    70,    72,    66,    71,    73,    67,    74,   -22,    75,    77,
    78,    81,    80,   -21,    82,    83,    86,    84,    85,    87,
    88,    89,    90,    94,    92,    93,    95,    96,    97,   101,
    99,   100,   102,   103,   104,   105,   106,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,    62,   119,-32768
};

static const short yypgoto[] = {-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768
};


#define	YYLAST		156


static const short yytable[] = {    53,
    54,    -1,    55,    56,    16,    57,    58,    59,    60,    61,
    62,    63,    64,    65,    66,    67,    68,    69,    70,    71,
    72,    73,    74,    75,    76,    77,     3,   221,   229,   222,
   230,     4,   122,    45,    46,    47,    48,    49,    50,     5,
    32,    33,    34,    35,    17,    18,     6,    51,    37,    38,
    39,    40,    41,    42,    43,    24,    19,     0,    26,    28,
    30,   256,   123,   124,   125,   126,   127,   128,   129,   130,
   131,   132,     0,   133,   134,   135,   136,   137,   138,     0,
   139,   140,   141,   142,   143,   144,   145,   146,   147,   148,
   149,   150,     0,   151,   152,     0,   153,   154,   155,   156,
   157,   158,   159,   160,   161,   162,   163,   164,   208,   209,
   210,   211,   212,   213,   216,   214,   215,   219,   257,     0,
   217,     0,   218,   220,     0,   224,   225,   226,   227,   228,
   234,   232,   233,   235,   236,     0,   237,   238,   239,   240,
   241,   242,   243,     0,   244,   245,   246,   247,   248,   249,
     0,   250,   251,   252,   253,   254
};

static const short yycheck[] = {    18,
    19,     0,    21,    22,    54,    24,    25,    26,    27,    28,
    29,    30,    31,    32,    33,    34,    35,    36,    37,    38,
    39,    40,    41,    42,    43,    44,     3,    50,    50,    52,
    52,     8,    56,    17,    18,    19,    20,    21,    22,    16,
     4,     5,     6,     7,    54,    54,    23,    31,     9,    10,
    11,    12,    13,    14,    15,    55,    54,    -1,    55,    55,
    55,     0,    56,    56,    56,    56,    56,    56,    56,    56,
    56,    56,    -1,    56,    56,    56,    56,    56,    56,    -1,
    56,    56,    56,    56,    56,    56,    56,    56,    56,    56,
    56,    56,    -1,    56,    56,    -1,    56,    56,    56,    56,
    56,    56,    56,    56,    56,    56,    56,    56,    45,    53,
    53,    53,    45,    45,    49,    46,    45,    51,     0,    -1,
    50,    -1,    50,    50,    -1,    51,    50,    50,    48,    50,
    45,    50,    50,    50,    50,    -1,    50,    50,    50,    50,
    47,    50,    50,    -1,    50,    50,    50,    47,    50,    50,
    -1,    50,    50,    50,    50,    50
};
/* -*-C-*-  Note some compilers choke on comments on `#line' lines.  */
#line 3 "/usr/share/misc/bison.simple"
/* This file comes from bison-1.28.  */

/* Skeleton output parser for bison,
   Copyright (C) 1984, 1989, 1990 Free Software Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.  */

/* As a special exception, when this file is copied by Bison into a
   Bison output file, you may use that output file without restriction.
   This special exception was added by the Free Software Foundation
   in version 1.24 of Bison.  */

/* This is the parser code that is written into each bison parser
  when the %semantic_parser declaration is not specified in the grammar.
  It was written by Richard Stallman by simplifying the hairy parser
  used when %semantic_parser is specified.  */

#ifndef YYSTACK_USE_ALLOCA
#ifdef alloca
#define YYSTACK_USE_ALLOCA
#else /* alloca not defined */
#ifdef __GNUC__
#define YYSTACK_USE_ALLOCA
#define alloca __builtin_alloca
#else /* not GNU C.  */
#if (!defined (__STDC__) && defined (sparc)) || defined (__sparc__) || defined (__sparc) || defined (__sgi) || (defined (__sun) && defined (__i386))
#define YYSTACK_USE_ALLOCA
#include <alloca.h>
#else /* not sparc */
/* We think this test detects Watcom and Microsoft C.  */
/* This used to test MSDOS, but that is a bad idea
   since that symbol is in the user namespace.  */
#if (defined (_MSDOS) || defined (_MSDOS_)) && !defined (__TURBOC__)
#if 0 /* No need for malloc.h, which pollutes the namespace;
	 instead, just don't use alloca.  */
#include <malloc.h>
#endif
#else /* not MSDOS, or __TURBOC__ */
#if defined(_AIX)
/* I don't know what this was needed for, but it pollutes the namespace.
   So I turned it off.   rms, 2 May 1997.  */
/* #include <malloc.h>  */
 #pragma alloca
#define YYSTACK_USE_ALLOCA
#else /* not MSDOS, or __TURBOC__, or _AIX */
#if 0
#ifdef __hpux /* haible@ilog.fr says this works for HPUX 9.05 and up,
		 and on HPUX 10.  Eventually we can turn this on.  */
#define YYSTACK_USE_ALLOCA
#define alloca __builtin_alloca
#endif /* __hpux */
#endif
#endif /* not _AIX */
#endif /* not MSDOS, or __TURBOC__ */
#endif /* not sparc */
#endif /* not GNU C */
#endif /* alloca not defined */
#endif /* YYSTACK_USE_ALLOCA not defined */

#ifdef YYSTACK_USE_ALLOCA
#define YYSTACK_ALLOC alloca
#else
#define YYSTACK_ALLOC malloc
#endif

/* Note: there must be only one dollar sign in this file.
   It is replaced by the list of actions, each action
   as one case of the switch.  */

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		-2
#define YYEOF		0
#define YYACCEPT	goto yyacceptlab
#define YYABORT 	goto yyabortlab
#define YYERROR		goto yyerrlab1
/* Like YYERROR except do call yyerror.
   This remains here temporarily to ease the
   transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */
#define YYFAIL		goto yyerrlab
#define YYRECOVERING()  (!!yyerrstatus)
#define YYBACKUP(token, value) \
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    { yychar = (token), yylval = (value);			\
      yychar1 = YYTRANSLATE (yychar);				\
      YYPOPSTACK;						\
      goto yybackup;						\
    }								\
  else								\
    { yyerror ("syntax error: cannot back up"); YYERROR; }	\
while (0)

#define YYTERROR	1
#define YYERRCODE	256

#ifndef YYPURE
#define YYLEX		yylex()
#endif

#ifdef YYPURE
#ifdef YYLSP_NEEDED
#ifdef YYLEX_PARAM
#define YYLEX		yylex(&yylval, &yylloc, YYLEX_PARAM)
#else
#define YYLEX		yylex(&yylval, &yylloc)
#endif
#else /* not YYLSP_NEEDED */
#ifdef YYLEX_PARAM
#define YYLEX		yylex(&yylval, YYLEX_PARAM)
#else
#define YYLEX		yylex(&yylval)
#endif
#endif /* not YYLSP_NEEDED */
#endif

/* If nonreentrant, generate the variables here */

#ifndef YYPURE

int	yychar;			/*  the lookahead symbol		*/
YYSTYPE	yylval;			/*  the semantic value of the		*/
				/*  lookahead symbol			*/

#ifdef YYLSP_NEEDED
YYLTYPE yylloc;			/*  location data for the lookahead	*/
				/*  symbol				*/
#endif

int yynerrs;			/*  number of parse errors so far       */
#endif  /* not YYPURE */

#if YYDEBUG != 0
int yydebug;			/*  nonzero means print parse trace	*/
/* Since this is uninitialized, it does not stop multiple parsers
   from coexisting.  */
#endif

/*  YYINITDEPTH indicates the initial size of the parser's stacks	*/

#ifndef	YYINITDEPTH
#define YYINITDEPTH 200
#endif

/*  YYMAXDEPTH is the maximum size the stacks can grow to
    (effective only if the built-in stack extension method is used).  */

#if YYMAXDEPTH == 0
#undef YYMAXDEPTH
#endif

#ifndef YYMAXDEPTH
#define YYMAXDEPTH 10000
#endif

/* Define __yy_memcpy.  Note that the size argument
   should be passed with type unsigned int, because that is what the non-GCC
   definitions require.  With GCC, __builtin_memcpy takes an arg
   of type size_t, but it can handle unsigned int.  */

#if __GNUC__ > 1		/* GNU C and GNU C++ define this.  */
#define __yy_memcpy(TO,FROM,COUNT)	__builtin_memcpy(TO,FROM,COUNT)
#else				/* not GNU C or C++ */
#ifndef __cplusplus

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__yy_memcpy (to, from, count)
     char *to;
     char *from;
     unsigned int count;
{
  register char *f = from;
  register char *t = to;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#else /* __cplusplus */

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__yy_memcpy (char *to, char *from, unsigned int count)
{
  register char *t = to;
  register char *f = from;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#endif
#endif

#line 217 "/usr/share/misc/bison.simple"

/* The user can define YYPARSE_PARAM as the name of an argument to be passed
   into yyparse.  The argument should have type void *.
   It should actually point to an object.
   Grammar actions can access the variable by casting it
   to the proper pointer type.  */

#ifdef YYPARSE_PARAM
#ifdef __cplusplus
#define YYPARSE_PARAM_ARG void *YYPARSE_PARAM
#define YYPARSE_PARAM_DECL
#else /* not __cplusplus */
#define YYPARSE_PARAM_ARG YYPARSE_PARAM
#define YYPARSE_PARAM_DECL void *YYPARSE_PARAM;
#endif /* not __cplusplus */
#else /* not YYPARSE_PARAM */
#define YYPARSE_PARAM_ARG
#define YYPARSE_PARAM_DECL
#endif /* not YYPARSE_PARAM */

/* Prevent warning if -Wstrict-prototypes.  */
#ifdef __GNUC__
#ifdef YYPARSE_PARAM
int yyparse (void *);
#else
int yyparse (void);
#endif
#endif

int
yyparse(YYPARSE_PARAM_ARG)
     YYPARSE_PARAM_DECL
{
  register int yystate;
  register int yyn;
  register short *yyssp;
  register YYSTYPE *yyvsp;
  int yyerrstatus;	/*  number of tokens to shift before error messages enabled */
  int yychar1 = 0;		/*  lookahead token as an internal (translated) token number */

  short	yyssa[YYINITDEPTH];	/*  the state stack			*/
  YYSTYPE yyvsa[YYINITDEPTH];	/*  the semantic value stack		*/

  short *yyss = yyssa;		/*  refer to the stacks thru separate pointers */
  YYSTYPE *yyvs = yyvsa;	/*  to allow yyoverflow to reallocate them elsewhere */

#ifdef YYLSP_NEEDED
  YYLTYPE yylsa[YYINITDEPTH];	/*  the location stack			*/
  YYLTYPE *yyls = yylsa;
  YYLTYPE *yylsp;

#define YYPOPSTACK   (yyvsp--, yyssp--, yylsp--)
#else
#define YYPOPSTACK   (yyvsp--, yyssp--)
#endif

  int yystacksize = YYINITDEPTH;
  int yyfree_stacks = 0;

#ifdef YYPURE
  int yychar;
  YYSTYPE yylval;
  int yynerrs;
#ifdef YYLSP_NEEDED
  YYLTYPE yylloc;
#endif
#endif

  YYSTYPE yyval;		/*  the variable used to return		*/
				/*  semantic values from the action	*/
				/*  routines				*/

  int yylen;

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Starting parse\n");
#endif

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss - 1;
  yyvsp = yyvs;
#ifdef YYLSP_NEEDED
  yylsp = yyls;
#endif

/* Push a new state, which is found in  yystate  .  */
/* In all cases, when you get here, the value and location stacks
   have just been pushed. so pushing a state here evens the stacks.  */
yynewstate:

  *++yyssp = yystate;

  if (yyssp >= yyss + yystacksize - 1)
    {
      /* Give user a chance to reallocate the stack */
      /* Use copies of these so that the &'s don't force the real ones into memory. */
      YYSTYPE *yyvs1 = yyvs;
      short *yyss1 = yyss;
#ifdef YYLSP_NEEDED
      YYLTYPE *yyls1 = yyls;
#endif

      /* Get the current used size of the three stacks, in elements.  */
      int size = yyssp - yyss + 1;

#ifdef yyoverflow
      /* Each stack pointer address is followed by the size of
	 the data in use in that stack, in bytes.  */
#ifdef YYLSP_NEEDED
      /* This used to be a conditional around just the two extra args,
	 but that might be undefined if yyoverflow is a macro.  */
      yyoverflow("parser stack overflow",
		 &yyss1, size * sizeof (*yyssp),
		 &yyvs1, size * sizeof (*yyvsp),
		 &yyls1, size * sizeof (*yylsp),
		 &yystacksize);
#else
      yyoverflow("parser stack overflow",
		 &yyss1, size * sizeof (*yyssp),
		 &yyvs1, size * sizeof (*yyvsp),
		 &yystacksize);
#endif

      yyss = yyss1; yyvs = yyvs1;
#ifdef YYLSP_NEEDED
      yyls = yyls1;
#endif
#else /* no yyoverflow */
      /* Extend the stack our own way.  */
      if (yystacksize >= YYMAXDEPTH)
	{
	  yyerror("parser stack overflow");
	  if (yyfree_stacks)
	    {
	      free (yyss);
	      free (yyvs);
#ifdef YYLSP_NEEDED
	      free (yyls);
#endif
	    }
	  return 2;
	}
      yystacksize *= 2;
      if (yystacksize > YYMAXDEPTH)
	yystacksize = YYMAXDEPTH;
#ifndef YYSTACK_USE_ALLOCA
      yyfree_stacks = 1;
#endif
      yyss = (short *) YYSTACK_ALLOC (yystacksize * sizeof (*yyssp));
      __yy_memcpy ((char *)yyss, (char *)yyss1,
		   size * (unsigned int) sizeof (*yyssp));
      yyvs = (YYSTYPE *) YYSTACK_ALLOC (yystacksize * sizeof (*yyvsp));
      __yy_memcpy ((char *)yyvs, (char *)yyvs1,
		   size * (unsigned int) sizeof (*yyvsp));
#ifdef YYLSP_NEEDED
      yyls = (YYLTYPE *) YYSTACK_ALLOC (yystacksize * sizeof (*yylsp));
      __yy_memcpy ((char *)yyls, (char *)yyls1,
		   size * (unsigned int) sizeof (*yylsp));
#endif
#endif /* no yyoverflow */

      yyssp = yyss + size - 1;
      yyvsp = yyvs + size - 1;
#ifdef YYLSP_NEEDED
      yylsp = yyls + size - 1;
#endif

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Stack size increased to %d\n", yystacksize);
#endif

      if (yyssp >= yyss + yystacksize - 1)
	YYABORT;
    }

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Entering state %d\n", yystate);
#endif

  goto yybackup;
 yybackup:

/* Do appropriate processing given the current state.  */
/* Read a lookahead token if we need one and don't already have one.  */
/* yyresume: */

  /* First try to decide what to do without reference to lookahead token.  */

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* yychar is either YYEMPTY or YYEOF
     or a valid token in external form.  */

  if (yychar == YYEMPTY)
    {
#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Reading a token: ");
#endif
      yychar = YYLEX;
    }

  /* Convert token to internal form (in yychar1) for indexing tables with */

  if (yychar <= 0)		/* This means end of input. */
    {
      yychar1 = 0;
      yychar = YYEOF;		/* Don't call YYLEX any more */

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Now at end of input.\n");
#endif
    }
  else
    {
      yychar1 = YYTRANSLATE(yychar);

#if YYDEBUG != 0
      if (yydebug)
	{
	  fprintf (stderr, "Next token is %d (%s", yychar, yytname[yychar1]);
	  /* Give the individual parser a way to print the precise meaning
	     of a token, for further debugging info.  */
#ifdef YYPRINT
	  YYPRINT (stderr, yychar, yylval);
#endif
	  fprintf (stderr, ")\n");
	}
#endif
    }

  yyn += yychar1;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != yychar1)
    goto yydefault;

  yyn = yytable[yyn];

  /* yyn is what to do for this token type in this state.
     Negative => reduce, -yyn is rule number.
     Positive => shift, yyn is new state.
       New state is final state => don't bother to shift,
       just return success.
     0, or most negative number => error.  */

  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrlab;

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Shift the lookahead token.  */

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Shifting token %d (%s), ", yychar, yytname[yychar1]);
#endif

  /* Discard the token being shifted unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  *++yyvsp = yylval;
#ifdef YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  /* count tokens shifted since error; after three, turn off error status.  */
  if (yyerrstatus) yyerrstatus--;

  yystate = yyn;
  goto yynewstate;

/* Do the default action for the current state.  */
yydefault:

  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;

/* Do a reduction.  yyn is the number of a rule to reduce with.  */
yyreduce:
  yylen = yyr2[yyn];
  if (yylen > 0)
    yyval = yyvsp[1-yylen]; /* implement default value of the action */

#if YYDEBUG != 0
  if (yydebug)
    {
      int i;

      fprintf (stderr, "Reducing via rule %d (line %d), ",
	       yyn, yyrline[yyn]);

      /* Print the symbols being reduced, and their result.  */
      for (i = yyprhs[yyn]; yyrhs[i] > 0; i++)
	fprintf (stderr, "%s ", yytname[yyrhs[i]]);
      fprintf (stderr, " -> %s\n", yytname[yyr1[yyn]]);
    }
#endif


  switch (yyn) {

case 3:
#line 392 "Config-parse.yy"
{
                               expected_token = CFG_BLOCK_ID;
                             ;
    break;}
case 9:
#line 405 "Config-parse.yy"
{
			       current_block_type = CFG_ALGORITHM;

                               algorithm_begin_line = config_file_line_number;

                               algorithm_information.name = 0;
                               algorithm_information.path_to_program = 0;
                               algorithm_information.extra_parameters = 0;
			       algorithm_information.enabled = true;

                               expected_token = CFG_LBRACE;
                             ;
    break;}
case 10:
#line 418 "Config-parse.yy"
{
                               if (algorithm_information.name == 0)
                               {
                                 algorithm_information.name =
                                   new string("Algorithm ");
				 algorithm_information.name->append
				   (::StringUtil::toString
				    (parser_cfg->algorithms.size()));
                               }
                               parser_cfg->algorithms.push_back
                                 (algorithm_information);
                               if (algorithm_information.path_to_program == 0)
                               {
				 throw Configuration::ConfigurationException
				         (::StringUtil::toString
					    (algorithm_begin_line)
					    + "--"
					    + ::StringUtil::toString
					        (config_file_line_number),
					  "missing path to executable (`"
					  + *(algorithm_information.name)
                                          + "')");
                               }
                             ;
    break;}
case 12:
#line 446 "Config-parse.yy"
{
                               expected_token = CFG_OPTION_ID;
                             ;
    break;}
case 14:
#line 453 "Config-parse.yy"
{
			       current_option_type = CFG_ENABLED;
			       expected_token = CFG_EQUALS;
			     ;
    break;}
case 15:
#line 458 "Config-parse.yy"
{
			       expected_token = CFG_TRUTH_VALUE;
			     ;
    break;}
case 16:
#line 462 "Config-parse.yy"
{
			       algorithm_information.enabled = yyvsp[0].truth_value;
			     ;
    break;}
case 17:
#line 467 "Config-parse.yy"
{
			       current_option_type = CFG_NAME;
                               expected_token = CFG_EQUALS;
                             ;
    break;}
case 18:
#line 472 "Config-parse.yy"
{
                               expected_token = CFG_STRING_CONSTANT;
                             ;
    break;}
case 19:
#line 476 "Config-parse.yy"
{
                               algorithm_information.name = yyvsp[0].str;
                             ;
    break;}
case 20:
#line 481 "Config-parse.yy"
{
			       current_option_type = CFG_PARAMETERS;
                               expected_token = CFG_EQUALS;
                             ;
    break;}
case 21:
#line 486 "Config-parse.yy"
{
                               expected_token = CFG_STRING_CONSTANT;
                             ;
    break;}
case 22:
#line 490 "Config-parse.yy"
{
                               algorithm_information.extra_parameters = yyvsp[0].str;
                             ;
    break;}
case 23:
#line 495 "Config-parse.yy"
{
			       current_option_type = CFG_PROGRAMPATH;
                               expected_token = CFG_EQUALS;
                             ;
    break;}
case 24:
#line 500 "Config-parse.yy"
{
                               expected_token = CFG_STRING_CONSTANT;
                             ;
    break;}
case 25:
#line 504 "Config-parse.yy"
{
                               algorithm_information.path_to_program = yyvsp[0].str;
                             ;
    break;}
case 26:
#line 510 "Config-parse.yy"
{
			       current_block_type = CFG_GLOBALOPTIONS;
                               expected_token = CFG_LBRACE;
                             ;
    break;}
case 29:
#line 519 "Config-parse.yy"
{
                               expected_token = CFG_OPTION_ID;
                             ;
    break;}
case 31:
#line 526 "Config-parse.yy"
{
			       current_option_type = CFG_COMPARISONTEST;
			       expected_token = CFG_EQUALS;
			     ;
    break;}
case 32:
#line 531 "Config-parse.yy"
{
			       expected_token = CFG_TRUTH_VALUE;
			     ;
    break;}
case 33:
#line 535 "Config-parse.yy"
{
			       if (!isLocked(CFG_COMPARISONTEST))
				 parser_cfg->global_options.do_comp_test = yyvsp[0].truth_value;
			     ;
    break;}
case 34:
#line 541 "Config-parse.yy"
{
			       current_option_type = CFG_CONSISTENCYTEST;
			       expected_token = CFG_EQUALS;
			     ;
    break;}
case 35:
#line 546 "Config-parse.yy"
{
			       expected_token = CFG_TRUTH_VALUE;
			     ;
    break;}
case 36:
#line 550 "Config-parse.yy"
{
			       if (!isLocked(CFG_CONSISTENCYTEST))
				 parser_cfg->global_options.do_cons_test = yyvsp[0].truth_value;
			     ;
    break;}
case 37:
#line 556 "Config-parse.yy"
{
			       current_option_type = CFG_INTERACTIVE;
                               expected_token = CFG_EQUALS;
                             ;
    break;}
case 38:
#line 561 "Config-parse.yy"
{
                               expected_token = CFG_INTERACTIVITY_VALUE;
                             ;
    break;}
case 39:
#line 565 "Config-parse.yy"
{
			       if (!isLocked(CFG_INTERACTIVE))
				 parser_cfg->global_options.interactive = yyvsp[0].interactivity_value;
                             ;
    break;}
case 40:
#line 571 "Config-parse.yy"
{
			       current_option_type = CFG_INTERSECTIONTEST;
			       expected_token = CFG_EQUALS;
			     ;
    break;}
case 41:
#line 576 "Config-parse.yy"
{
			       expected_token = CFG_TRUTH_VALUE;
			     ;
    break;}
case 42:
#line 580 "Config-parse.yy"
{
			       if (!isLocked(CFG_INTERSECTIONTEST))
				 parser_cfg->global_options.do_intr_test = yyvsp[0].truth_value;
			     ;
    break;}
case 43:
#line 586 "Config-parse.yy"
{
			       current_option_type = CFG_MODELCHECK;
			       expected_token = CFG_EQUALS;
			     ;
    break;}
case 44:
#line 591 "Config-parse.yy"
{
			       expected_token = CFG_PRODUCT_TYPE_VALUE;
			     ;
    break;}
case 45:
#line 595 "Config-parse.yy"
{
			       if (!isLocked(CFG_MODELCHECK))
				 parser_cfg->global_options.product_mode = yyvsp[0].product_type_value;
			     ;
    break;}
case 46:
#line 601 "Config-parse.yy"
{
			       current_option_type = CFG_ROUNDS;
                               expected_token = CFG_EQUALS;
                             ;
    break;}
case 47:
#line 606 "Config-parse.yy"
{
                               expected_token = CFG_INTEGER;
                             ;
    break;}
case 48:
#line 610 "Config-parse.yy"
{
			       if (!isLocked(CFG_ROUNDS))
			       {
				 checkIntegerRange
	                           (yyvsp[0].integer, Configuration::ROUND_COUNT_RANGE,
                                    true);
				 parser_cfg->global_options.number_of_rounds
				   = yyvsp[0].integer;
			       }
                             ;
    break;}
case 49:
#line 622 "Config-parse.yy"
{
			       current_option_type = CFG_VERBOSITY;
                               expected_token = CFG_EQUALS;
                             ;
    break;}
case 50:
#line 627 "Config-parse.yy"
{
                               expected_token = CFG_INTEGER;
                             ;
    break;}
case 51:
#line 631 "Config-parse.yy"
{
			       if (!isLocked(CFG_VERBOSITY))
			       {
				 checkIntegerRange
                                   (yyvsp[0].integer, Configuration::VERBOSITY_RANGE, true);
				 parser_cfg->global_options.verbosity = yyvsp[0].integer;
			       }
                             ;
    break;}
case 52:
#line 642 "Config-parse.yy"
{
			       current_block_type = CFG_STATESPACEOPTIONS;
                               expected_token = CFG_LBRACE;
                             ;
    break;}
case 55:
#line 651 "Config-parse.yy"
{
                               expected_token = CFG_OPTION_ID;
                             ;
    break;}
case 57:
#line 658 "Config-parse.yy"
{
			       current_option_type = CFG_CHANGEINTERVAL;
                               expected_token = CFG_EQUALS;
                             ;
    break;}
case 58:
#line 663 "Config-parse.yy"
{
                               expected_token = CFG_INTEGER;
                             ;
    break;}
case 59:
#line 667 "Config-parse.yy"
{
			       if (!isLocked(CFG_CHANGEINTERVAL))
			       {
				 checkIntegerRange
                                   (yyvsp[0].integer, Configuration::GENERATION_RANGE, true);
				 parser_cfg->global_options.
				   statespace_change_interval = yyvsp[0].integer;
			       }
                             ;
    break;}
case 60:
#line 678 "Config-parse.yy"
{
			       current_option_type = CFG_EDGEPROBABILITY;
                               expected_token = CFG_EQUALS;
                             ;
    break;}
case 61:
#line 683 "Config-parse.yy"
{
                               expected_token = CFG_REAL;
                             ;
    break;}
case 62:
#line 687 "Config-parse.yy"
{
			       if (!isLocked(CFG_EDGEPROBABILITY))
			       {
				 checkProbability(yyvsp[0].real);
				 parser_cfg->statespace_generator.
	                           edge_probability = yyvsp[0].real;
			       }
                             ;
    break;}
case 63:
#line 697 "Config-parse.yy"
{
			       current_option_type = CFG_GENERATEMODE;
			       expected_token = CFG_EQUALS;
			     ;
    break;}
case 64:
#line 702 "Config-parse.yy"
{
			       expected_token = CFG_STATESPACE_MODE_VALUE;
			     ;
    break;}
case 65:
#line 706 "Config-parse.yy"
{
			       if (!isLocked(CFG_GENERATEMODE))
				 parser_cfg->global_options.
	                           statespace_generation_mode = yyvsp[0].statespace_mode_value;
			     ;
    break;}
case 66:
#line 713 "Config-parse.yy"
{
			       current_option_type = CFG_PROPOSITIONS;
                               expected_token = CFG_EQUALS;
                             ;
    break;}
case 67:
#line 718 "Config-parse.yy"
{
                               expected_token = CFG_INTEGER;
                             ;
    break;}
case 68:
#line 722 "Config-parse.yy"
{
			       if (!isLocked(CFG_PROPOSITIONS))
			       {
				 checkIntegerRange
                                   (yyvsp[0].integer, Configuration::PROPOSITION_COUNT_RANGE,
                                    true);
				 parser_cfg->statespace_generator.
	                           atoms_per_state = yyvsp[0].integer;
			       }
                             ;
    break;}
case 69:
#line 734 "Config-parse.yy"
{
			       current_option_type = CFG_RANDOMSEED;
                               expected_token = CFG_EQUALS;
                             ;
    break;}
case 70:
#line 739 "Config-parse.yy"
{
                               expected_token = CFG_INTEGER;
                             ;
    break;}
case 71:
#line 743 "Config-parse.yy"
{
			       if (!isLocked(CFG_RANDOMSEED))
				 parser_cfg->global_options.
                                   statespace_random_seed = yyvsp[0].integer;
                             ;
    break;}
case 72:
#line 750 "Config-parse.yy"
{
			       current_option_type = CFG_SIZE;
                               expected_token = CFG_EQUALS;
                             ;
    break;}
case 73:
#line 755 "Config-parse.yy"
{
                               expected_token = CFG_INTEGER_INTERVAL;
                             ;
    break;}
case 75:
#line 761 "Config-parse.yy"
{
			       current_option_type = CFG_TRUTHPROBABILITY;
                               expected_token = CFG_EQUALS;
                             ;
    break;}
case 76:
#line 766 "Config-parse.yy"
{
                               expected_token = CFG_REAL;
                             ;
    break;}
case 77:
#line 770 "Config-parse.yy"
{
			       if (!isLocked(CFG_TRUTHPROBABILITY))
			       {
				 checkProbability(yyvsp[0].real);
				 parser_cfg->statespace_generator.
                                   truth_probability = yyvsp[0].real;
			       }
                             ;
    break;}
case 78:
#line 781 "Config-parse.yy"
{
			       current_block_type = CFG_FORMULAOPTIONS;
                               expected_token = CFG_LBRACE;
                             ;
    break;}
case 81:
#line 790 "Config-parse.yy"
{
                               expected_token = CFG_OPTION_ID;
                             ;
    break;}
case 83:
#line 797 "Config-parse.yy"
{
			       current_option_type = CFG_ABBREVIATEDOPERATORS;
                               expected_token = CFG_EQUALS;
                             ;
    break;}
case 84:
#line 802 "Config-parse.yy"
{
                               expected_token = CFG_TRUTH_VALUE;
                             ;
    break;}
case 85:
#line 806 "Config-parse.yy"
{
			       if (!isLocked(CFG_ABBREVIATEDOPERATORS))
				 parser_cfg->formula_options.
				   allow_abbreviated_operators = yyvsp[0].truth_value;
                             ;
    break;}
case 86:
#line 813 "Config-parse.yy"
{
			       current_option_type = CFG_ANDPRIORITY;
                               expected_token = CFG_EQUALS;
                             ;
    break;}
case 87:
#line 818 "Config-parse.yy"
{
                               expected_token = CFG_INTEGER;
                             ;
    break;}
case 88:
#line 822 "Config-parse.yy"
{
			       if (!isLocked(CFG_ANDPRIORITY))
			       {
				 checkIntegerRange
                                   (yyvsp[0].integer, Configuration::PRIORITY_RANGE, true);
				 parser_cfg->formula_options.symbol_priority
	                           [::Ltl::LTL_CONJUNCTION] = yyvsp[0].integer;
			       }
                             ;
    break;}
case 89:
#line 833 "Config-parse.yy"
{
			       current_option_type = CFG_BEFOREPRIORITY;
                               expected_token = CFG_EQUALS;
                             ;
    break;}
case 90:
#line 838 "Config-parse.yy"
{
                               expected_token = CFG_INTEGER;
                             ;
    break;}
case 91:
#line 842 "Config-parse.yy"
{
			       if (!isLocked(CFG_BEFOREPRIORITY))
			       {
				 checkIntegerRange
                                   (yyvsp[0].integer, Configuration::PRIORITY_RANGE, true);
				 parser_cfg->formula_options.symbol_priority
	                           [::Ltl::LTL_BEFORE] = yyvsp[0].integer;
			       }
                             ;
    break;}
case 92:
#line 853 "Config-parse.yy"
{
			       current_option_type = CFG_CHANGEINTERVAL;
                               expected_token = CFG_EQUALS;
                             ;
    break;}
case 93:
#line 858 "Config-parse.yy"
{
                               expected_token = CFG_INTEGER;
                             ;
    break;}
case 94:
#line 862 "Config-parse.yy"
{
			       if (!isLocked(CFG_CHANGEINTERVAL))
			       {
				 checkIntegerRange
	                           (yyvsp[0].integer, Configuration::GENERATION_RANGE, true);
				 parser_cfg->global_options.
                                   formula_change_interval = yyvsp[0].integer;
			       }
                             ;
    break;}
case 95:
#line 873 "Config-parse.yy"
{
			       current_option_type
	                         = CFG_DEFAULTOPERATORPRIORITY;
                               expected_token = CFG_EQUALS;
                             ;
    break;}
case 96:
#line 879 "Config-parse.yy"
{
                               expected_token = CFG_INTEGER;
                             ;
    break;}
case 97:
#line 883 "Config-parse.yy"
{
			       if (!isLocked(CFG_DEFAULTOPERATORPRIORITY))
			       {
				 checkIntegerRange
                                   (yyvsp[0].integer, Configuration::PRIORITY_RANGE, true);
				 parser_cfg->formula_options.
	                           default_operator_priority = yyvsp[0].integer;
			       }
                             ;
    break;}
case 98:
#line 894 "Config-parse.yy"
{
			       current_option_type = CFG_EQUIVALENCEPRIORITY;
                               expected_token = CFG_EQUALS;
                             ;
    break;}
case 99:
#line 899 "Config-parse.yy"
{
                               expected_token = CFG_INTEGER;
                             ;
    break;}
case 100:
#line 903 "Config-parse.yy"
{
			       if (!isLocked(CFG_EQUIVALENCEPRIORITY))
			       {
				 checkIntegerRange
                                   (yyvsp[0].integer, Configuration::PRIORITY_RANGE, true);
				 parser_cfg->formula_options.symbol_priority
	                           [::Ltl::LTL_EQUIVALENCE] = yyvsp[0].integer;
			       }
                             ;
    break;}
case 101:
#line 914 "Config-parse.yy"
{
			       current_option_type = CFG_FALSEPRIORITY;
                               expected_token = CFG_EQUALS;
                             ;
    break;}
case 102:
#line 919 "Config-parse.yy"
{
                               expected_token = CFG_INTEGER;
                             ;
    break;}
case 103:
#line 923 "Config-parse.yy"
{
			       if (!isLocked(CFG_FALSEPRIORITY))
			       {
				 checkIntegerRange
                                   (yyvsp[0].integer, Configuration::PRIORITY_RANGE, true);
				 parser_cfg->formula_options.symbol_priority
                                   [::Ltl::LTL_FALSE] = yyvsp[0].integer;
			       }
                             ;
    break;}
case 104:
#line 934 "Config-parse.yy"
{
			       current_option_type = CFG_FINALLYPRIORITY;
                               expected_token = CFG_EQUALS;
                             ;
    break;}
case 105:
#line 939 "Config-parse.yy"
{
                               expected_token = CFG_INTEGER;
                             ;
    break;}
case 106:
#line 943 "Config-parse.yy"
{
			       if (!isLocked(CFG_FINALLYPRIORITY))
			       {
				 checkIntegerRange
                                   (yyvsp[0].integer, Configuration::PRIORITY_RANGE, true);
				 parser_cfg->formula_options.symbol_priority
                                   [::Ltl::LTL_FINALLY] = yyvsp[0].integer;
			       }
                             ;
    break;}
case 107:
#line 954 "Config-parse.yy"
{
			       current_option_type = CFG_GENERATEMODE;
                               expected_token = CFG_EQUALS;
                             ;
    break;}
case 108:
#line 959 "Config-parse.yy"
{
                               expected_token = CFG_FORMULA_MODE_VALUE;
                             ;
    break;}
case 109:
#line 963 "Config-parse.yy"
{
			       if (!isLocked(CFG_GENERATEMODE))
				 parser_cfg->formula_options.generate_mode
				   = yyvsp[0].formula_mode_value;
                             ;
    break;}
case 110:
#line 970 "Config-parse.yy"
{
			       current_option_type = CFG_GLOBALLYPRIORITY;
                               expected_token = CFG_EQUALS;
                             ;
    break;}
case 111:
#line 975 "Config-parse.yy"
{
                               expected_token = CFG_INTEGER;
                             ;
    break;}
case 112:
#line 979 "Config-parse.yy"
{
			       if (!isLocked(CFG_GLOBALLYPRIORITY))
			       {
				 checkIntegerRange
                                   (yyvsp[0].integer, Configuration::PRIORITY_RANGE, true);
				 parser_cfg->formula_options.symbol_priority
                                   [::Ltl::LTL_GLOBALLY] = yyvsp[0].integer;
			       }
                             ;
    break;}
case 113:
#line 990 "Config-parse.yy"
{
			       current_option_type = CFG_IMPLICATIONPRIORITY;
                               expected_token = CFG_EQUALS;
                             ;
    break;}
case 114:
#line 995 "Config-parse.yy"
{
                               expected_token = CFG_INTEGER;
                             ;
    break;}
case 115:
#line 999 "Config-parse.yy"
{
			       if (!isLocked(CFG_IMPLICATIONPRIORITY))
			       {
				 checkIntegerRange
                                   (yyvsp[0].integer, Configuration::PRIORITY_RANGE, true);
				 parser_cfg->formula_options.symbol_priority
                                   [::Ltl::LTL_IMPLICATION] = yyvsp[0].integer;
			       }
                             ;
    break;}
case 116:
#line 1010 "Config-parse.yy"
{
			       current_option_type = CFG_NEXTPRIORITY;
                               expected_token = CFG_EQUALS;
                             ;
    break;}
case 117:
#line 1015 "Config-parse.yy"
{
                               expected_token = CFG_INTEGER;
                             ;
    break;}
case 118:
#line 1019 "Config-parse.yy"
{
			       if (!isLocked(CFG_NEXTPRIORITY))
			       {
				 checkIntegerRange
                                   (yyvsp[0].integer, Configuration::PRIORITY_RANGE, true);
				 parser_cfg->formula_options.symbol_priority
                                   [::Ltl::LTL_NEXT] = yyvsp[0].integer;
			       }
                             ;
    break;}
case 119:
#line 1030 "Config-parse.yy"
{
			       current_option_type = CFG_NOTPRIORITY;
                               expected_token = CFG_EQUALS;
                             ;
    break;}
case 120:
#line 1035 "Config-parse.yy"
{
                               expected_token = CFG_INTEGER;
                             ;
    break;}
case 121:
#line 1039 "Config-parse.yy"
{
			       if (!isLocked(CFG_NOTPRIORITY))
			       {
				 checkIntegerRange
                                   (yyvsp[0].integer, Configuration::PRIORITY_RANGE, true);
				 parser_cfg->formula_options.symbol_priority
                                   [::Ltl::LTL_NEGATION] = yyvsp[0].integer;
			       }
                             ;
    break;}
case 122:
#line 1050 "Config-parse.yy"
{
			       current_option_type = CFG_ORPRIORITY;
                               expected_token = CFG_EQUALS;
                             ;
    break;}
case 123:
#line 1055 "Config-parse.yy"
{
                               expected_token = CFG_INTEGER;
                             ;
    break;}
case 124:
#line 1059 "Config-parse.yy"
{
			       if (!isLocked(CFG_ORPRIORITY))
			       {
				 checkIntegerRange
                                   (yyvsp[0].integer, Configuration::PRIORITY_RANGE, true);
				 parser_cfg->formula_options.symbol_priority
                                   [::Ltl::LTL_DISJUNCTION] = yyvsp[0].integer;
			       }
                             ;
    break;}
case 125:
#line 1070 "Config-parse.yy"
{
			       current_option_type = CFG_OUTPUTMODE;
                               expected_token = CFG_EQUALS;
                             ;
    break;}
case 126:
#line 1075 "Config-parse.yy"
{
                               expected_token = CFG_FORMULA_MODE_VALUE;
                             ;
    break;}
case 127:
#line 1079 "Config-parse.yy"
{
			       if (!isLocked(CFG_OUTPUTMODE))
				 parser_cfg->formula_options.output_mode = yyvsp[0].formula_mode_value;
                             ;
    break;}
case 128:
#line 1085 "Config-parse.yy"
{
			       current_option_type = CFG_PROPOSITIONPRIORITY;
                               expected_token = CFG_EQUALS;
                             ;
    break;}
case 129:
#line 1090 "Config-parse.yy"
{
                               expected_token = CFG_INTEGER;
                             ;
    break;}
case 130:
#line 1094 "Config-parse.yy"
{
			       if (!isLocked(CFG_PROPOSITIONPRIORITY))
			       {
				 checkIntegerRange
                                   (yyvsp[0].integer, Configuration::PRIORITY_RANGE, true);
				 parser_cfg->formula_options.symbol_priority
                                   [::Ltl::LTL_ATOM] = yyvsp[0].integer;
			       }
                             ;
    break;}
case 131:
#line 1105 "Config-parse.yy"
{
			       current_option_type = CFG_PROPOSITIONS;
                               expected_token = CFG_EQUALS;
                             ;
    break;}
case 132:
#line 1110 "Config-parse.yy"
{
                               expected_token = CFG_INTEGER;
                             ;
    break;}
case 133:
#line 1114 "Config-parse.yy"
{
			       if (!isLocked(CFG_PROPOSITIONS))
			       {
				 checkIntegerRange
                                   (yyvsp[0].integer, Configuration::PROPOSITION_COUNT_RANGE,
                                    true);
				 parser_cfg->formula_options.
                                   formula_generator.
				   number_of_available_variables = yyvsp[0].integer;
			       }
                             ;
    break;}
case 134:
#line 1127 "Config-parse.yy"
{
			       current_option_type = CFG_RANDOMSEED;
                               expected_token = CFG_EQUALS;
                             ;
    break;}
case 135:
#line 1132 "Config-parse.yy"
{
                               expected_token = CFG_INTEGER;
                             ;
    break;}
case 136:
#line 1136 "Config-parse.yy"
{
			       if (!isLocked(CFG_RANDOMSEED))
				 parser_cfg->global_options.formula_random_seed
                                   = yyvsp[0].integer;
                             ;
    break;}
case 137:
#line 1143 "Config-parse.yy"
{
			       current_option_type = CFG_RELEASEPRIORITY;
                               expected_token = CFG_EQUALS;
                             ;
    break;}
case 138:
#line 1148 "Config-parse.yy"
{
                               expected_token = CFG_INTEGER;
                             ;
    break;}
case 139:
#line 1152 "Config-parse.yy"
{
			       if (!isLocked(CFG_RELEASEPRIORITY))
			       {
				 checkIntegerRange
                                   (yyvsp[0].integer, Configuration::PRIORITY_RANGE, true);
				 parser_cfg->formula_options.symbol_priority
                                   [::Ltl::LTL_V] = yyvsp[0].integer;
			       }
                             ;
    break;}
case 140:
#line 1163 "Config-parse.yy"
{
			       current_option_type = CFG_SIZE;
                               expected_token = CFG_EQUALS;
                             ;
    break;}
case 141:
#line 1168 "Config-parse.yy"
{
                               expected_token = CFG_INTEGER_INTERVAL;
                             ;
    break;}
case 143:
#line 1174 "Config-parse.yy"
{
			       current_option_type = CFG_STRONGRELEASEPRIORITY;
                               expected_token = CFG_EQUALS;
                             ;
    break;}
case 144:
#line 1179 "Config-parse.yy"
{
                               expected_token = CFG_INTEGER;
                             ;
    break;}
case 145:
#line 1183 "Config-parse.yy"
{
			       if (!isLocked(CFG_STRONGRELEASEPRIORITY))
			       {
				 checkIntegerRange
                                   (yyvsp[0].integer, Configuration::PRIORITY_RANGE, true);
				 parser_cfg->formula_options.symbol_priority
                                   [::Ltl::LTL_STRONG_RELEASE] = yyvsp[0].integer;
			       }
                             ;
    break;}
case 146:
#line 1194 "Config-parse.yy"
{
			       current_option_type = CFG_TRUEPRIORITY;
                               expected_token = CFG_EQUALS;
                             ;
    break;}
case 147:
#line 1199 "Config-parse.yy"
{
                               expected_token = CFG_INTEGER;
                             ;
    break;}
case 148:
#line 1203 "Config-parse.yy"
{
			       if (!isLocked(CFG_TRUEPRIORITY))
			       {
				 checkIntegerRange
                                   (yyvsp[0].integer, Configuration::PRIORITY_RANGE, true);
				 parser_cfg->formula_options.symbol_priority
                                   [::Ltl::LTL_TRUE] = yyvsp[0].integer;
			       }
                             ;
    break;}
case 149:
#line 1214 "Config-parse.yy"
{
			       current_option_type = CFG_UNTILPRIORITY;
                               expected_token = CFG_EQUALS;
                             ;
    break;}
case 150:
#line 1219 "Config-parse.yy"
{
                               expected_token = CFG_INTEGER;
                             ;
    break;}
case 151:
#line 1223 "Config-parse.yy"
{
			       if (!isLocked(CFG_UNTILPRIORITY))
			       {
				 checkIntegerRange
                                   (yyvsp[0].integer, Configuration::PRIORITY_RANGE, true);
				 parser_cfg->formula_options.symbol_priority
                                   [::Ltl::LTL_UNTIL] = yyvsp[0].integer;
			       }
                             ;
    break;}
case 152:
#line 1234 "Config-parse.yy"
{
			       current_option_type = CFG_WEAKUNTILPRIORITY;
                               expected_token = CFG_EQUALS;
                             ;
    break;}
case 153:
#line 1239 "Config-parse.yy"
{
                               expected_token = CFG_INTEGER;
                             ;
    break;}
case 154:
#line 1243 "Config-parse.yy"
{
			       if (!isLocked(CFG_WEAKUNTILPRIORITY))
			       {
				 checkIntegerRange
                                   (yyvsp[0].integer, Configuration::PRIORITY_RANGE, true);
				 parser_cfg->formula_options.symbol_priority
                                   [::Ltl::LTL_WEAK_UNTIL] = yyvsp[0].integer;
			       }
                             ;
    break;}
case 155:
#line 1254 "Config-parse.yy"
{
			       current_option_type = CFG_XORPRIORITY;
                               expected_token = CFG_EQUALS;
                             ;
    break;}
case 156:
#line 1259 "Config-parse.yy"
{
                               expected_token = CFG_INTEGER;
                             ;
    break;}
case 157:
#line 1263 "Config-parse.yy"
{
			       if (!isLocked(CFG_XORPRIORITY))
			       {
				 checkIntegerRange
                                   (yyvsp[0].integer, Configuration::PRIORITY_RANGE, true);
				 parser_cfg->formula_options.symbol_priority
                                   [::Ltl::LTL_XOR] = yyvsp[0].integer;
			       }
                             ;
    break;}
case 158:
#line 1275 "Config-parse.yy"
{
			       if (!isLocked(CFG_SIZE))
			       {
				 checkIntegerRange
                                   (yyvsp[0].integer, Configuration::FORMULA_SIZE_RANGE,
                                    true);
				 parser_cfg->formula_options.formula_generator.
                                   size = yyvsp[0].integer;
				 parser_cfg->formula_options.formula_generator.
				   max_size = yyvsp[0].integer;
			       }
                             ;
    break;}
case 159:
#line 1289 "Config-parse.yy"
{
			       if (!isLocked(CFG_SIZE))
			       {
				 checkIntegerRange
                                   (yyvsp[0].integer_interval.min, Configuration::FORMULA_SIZE_RANGE,
				    true);

				 Configuration::IntegerRange max_len_range
	                           (Configuration::FORMULA_MAX_SIZE_RANGE);

				 max_len_range.min = yyvsp[0].integer_interval.min;

				 checkIntegerRange(yyvsp[0].integer_interval.max, max_len_range,
						   true);

				 parser_cfg->formula_options.formula_generator.
				   size = yyvsp[0].integer_interval.min;
				 parser_cfg->formula_options.formula_generator.
				   max_size = yyvsp[0].integer_interval.max;
			       }
			     ;
    break;}
case 160:
#line 1313 "Config-parse.yy"
{
			       if (!isLocked(CFG_SIZE))
			       {
				 checkIntegerRange
                                   (yyvsp[0].integer, Configuration::STATESPACE_SIZE_RANGE,
				    true);
				 parser_cfg->statespace_generator.min_size
                                   = yyvsp[0].integer;
				 parser_cfg->statespace_generator.max_size
                                   = yyvsp[0].integer;
			       }
                             ;
    break;}
case 161:
#line 1327 "Config-parse.yy"
{
			       if (!isLocked(CFG_SIZE))
			       {
				 checkIntegerRange
                                   (yyvsp[0].integer_interval.min,
                                    Configuration::STATESPACE_SIZE_RANGE,
                                    true);

				 Configuration::IntegerRange max_size_range
                                   (Configuration::STATESPACE_MAX_SIZE_RANGE);

				 checkIntegerRange(yyvsp[0].integer_interval.max, max_size_range,
						   true);

				 parser_cfg->statespace_generator.min_size
                                   = yyvsp[0].integer_interval.min;
				 parser_cfg->statespace_generator.max_size
                                   = yyvsp[0].integer_interval.max;
			       }
			     ;
    break;}
}
   /* the action file gets copied in in place of this dollarsign */
#line 543 "/usr/share/misc/bison.simple"

  yyvsp -= yylen;
  yyssp -= yylen;
#ifdef YYLSP_NEEDED
  yylsp -= yylen;
#endif

#if YYDEBUG != 0
  if (yydebug)
    {
      short *ssp1 = yyss - 1;
      fprintf (stderr, "state stack now");
      while (ssp1 != yyssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

  *++yyvsp = yyval;

#ifdef YYLSP_NEEDED
  yylsp++;
  if (yylen == 0)
    {
      yylsp->first_line = yylloc.first_line;
      yylsp->first_column = yylloc.first_column;
      yylsp->last_line = (yylsp-1)->last_line;
      yylsp->last_column = (yylsp-1)->last_column;
      yylsp->text = 0;
    }
  else
    {
      yylsp->last_line = (yylsp+yylen-1)->last_line;
      yylsp->last_column = (yylsp+yylen-1)->last_column;
    }
#endif

  /* Now "shift" the result of the reduction.
     Determine what state that goes to,
     based on the state we popped back to
     and the rule number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTBASE] + *yyssp;
  if (yystate >= 0 && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTBASE];

  goto yynewstate;

yyerrlab:   /* here on detecting error */

  if (! yyerrstatus)
    /* If not already recovering from an error, report this error.  */
    {
      ++yynerrs;

#ifdef YYERROR_VERBOSE
      yyn = yypact[yystate];

      if (yyn > YYFLAG && yyn < YYLAST)
	{
	  int size = 0;
	  char *msg;
	  int x, count;

	  count = 0;
	  /* Start X at -yyn if nec to avoid negative indexes in yycheck.  */
	  for (x = (yyn < 0 ? -yyn : 0);
	       x < (sizeof(yytname) / sizeof(char *)); x++)
	    if (yycheck[x + yyn] == x)
	      size += strlen(yytname[x]) + 15, count++;
	  msg = (char *) malloc(size + 15);
	  if (msg != 0)
	    {
	      strcpy(msg, "parse error");

	      if (count < 5)
		{
		  count = 0;
		  for (x = (yyn < 0 ? -yyn : 0);
		       x < (sizeof(yytname) / sizeof(char *)); x++)
		    if (yycheck[x + yyn] == x)
		      {
			strcat(msg, count == 0 ? ", expecting `" : " or `");
			strcat(msg, yytname[x]);
			strcat(msg, "'");
			count++;
		      }
		}
	      yyerror(msg);
	      free(msg);
	    }
	  else
	    yyerror ("parse error; also virtual memory exceeded");
	}
      else
#endif /* YYERROR_VERBOSE */
	yyerror("parse error");
    }

  goto yyerrlab1;
yyerrlab1:   /* here on error raised explicitly by an action */

  if (yyerrstatus == 3)
    {
      /* if just tried and failed to reuse lookahead token after an error, discard it.  */

      /* return failure if at end of input */
      if (yychar == YYEOF)
	YYABORT;

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Discarding token %d (%s).\n", yychar, yytname[yychar1]);
#endif

      yychar = YYEMPTY;
    }

  /* Else will try to reuse lookahead token
     after shifting the error token.  */

  yyerrstatus = 3;		/* Each real token shifted decrements this */

  goto yyerrhandle;

yyerrdefault:  /* current state does not do anything special for the error token. */

#if 0
  /* This is wrong; only states that explicitly want error tokens
     should shift them.  */
  yyn = yydefact[yystate];  /* If its default is to accept any token, ok.  Otherwise pop it.*/
  if (yyn) goto yydefault;
#endif

yyerrpop:   /* pop the current state because it cannot handle the error token */

  if (yyssp == yyss) YYABORT;
  yyvsp--;
  yystate = *--yyssp;
#ifdef YYLSP_NEEDED
  yylsp--;
#endif

#if YYDEBUG != 0
  if (yydebug)
    {
      short *ssp1 = yyss - 1;
      fprintf (stderr, "Error: state stack now");
      while (ssp1 != yyssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

yyerrhandle:

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yyerrdefault;

  yyn += YYTERROR;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != YYTERROR)
    goto yyerrdefault;

  yyn = yytable[yyn];
  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrpop;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrpop;

  if (yyn == YYFINAL)
    YYACCEPT;

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Shifting error token, ");
#endif

  *++yyvsp = yylval;
#ifdef YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  yystate = yyn;
  goto yynewstate;

 yyacceptlab:
  /* YYACCEPT comes here.  */
  if (yyfree_stacks)
    {
      free (yyss);
      free (yyvs);
#ifdef YYLSP_NEEDED
      free (yyls);
#endif
    }
  return 0;

 yyabortlab:
  /* YYABORT comes here.  */
  if (yyfree_stacks)
    {
      free (yyss);
      free (yyvs);
#ifdef YYLSP_NEEDED
      free (yyls);
#endif
    }
  return 1;
}
#line 1349 "Config-parse.yy"




/******************************************************************************
 *
 * Main interface to the parser.
 *
 *****************************************************************************/

/* ========================================================================= */
int parseConfiguration(FILE* stream, Configuration& configuration)
/* ----------------------------------------------------------------------------
 *
 * Description:   Main interface to the configuration file parser. Parses the
 *                configuration file and stores the results into the given
 *                Configuration object.
 *
 * Arguments:     stream         --  A pointer to a file from which the
 *                                   configuration should be read.  The file is
 *                                   assumed to be open for reading.
 *                configuration  --  A reference to a Configuration object in
 *                                   which the configuration should be stored.
 *
 * Returns:       
 *
 * ------------------------------------------------------------------------- */
{
  yyrestart(stream);
  parser_cfg = &configuration;
  config_file_line_number = 1;
  return yyparse();
}
